package cn.estsh.i3plus.core.apiservice.util;

import cn.estsh.i3plus.platform.common.tool.TimeTool;
import cn.estsh.i3plus.pojo.base.codemaker.SnowflakeIdMaker;
import cn.estsh.i3plus.pojo.base.enumutil.CommonEnumUtil;
import cn.estsh.i3plus.pojo.platform.bean.SysLocaleResource;
import org.apache.poi.openxml4j.exceptions.InvalidFormatException;
import org.apache.poi.ss.usermodel.CellType;
import org.apache.poi.ss.usermodel.Row;
import org.apache.poi.ss.usermodel.Sheet;
import org.apache.poi.ss.usermodel.Workbook;
import org.apache.poi.xssf.usermodel.XSSFWorkbook;

import java.io.*;

/**
 * @Description :
 * @Reference :
 * @Author : yunhao
 * @CreateDate : 2019-09-12 20:02
 * @Modify:
 **/
public class ResourceImportUtil {

    public static void main(String[] args) {
        File file = new File("C:\\Users\\yunha\\Desktop\\副本资源文件.xlsx");
        File sql = new File("C:\\Users\\yunha\\Desktop\\imppRource.sql");
        int i = 1;
        try {
            FileWriter fileWritter = new FileWriter(sql,false);
            BufferedWriter bufferWritter = new BufferedWriter(fileWritter);


            SnowflakeIdMaker snowflakeIdMaker = new SnowflakeIdMaker();
            Workbook wb = new XSSFWorkbook(file);
            // 前端资源
            Sheet webSheet = wb.getSheet("前端");
            Row row =null;
            SysLocaleResource sysLocaleResource = new SysLocaleResource();
            for (; i < webSheet.getLastRowNum(); i++) {
                row = webSheet.getRow(i);

                if(row == null||  row.getCell(2) == null||  row.getCell(3) == null){
                    continue;
}
                System.out.println(snowflakeIdMaker.nextId()+"行:"+i);
                row.getCell(2).setCellType(CellType.STRING);
                row.getCell(3).setCellType(CellType.STRING);
                sysLocaleResource.setId(snowflakeIdMaker.nextId());
                sysLocaleResource.setLanguageCode("CN/zh");
                sysLocaleResource.setLanguageNameRdd("简体中文");
                sysLocaleResource.setResourceType(CommonEnumUtil.SYS_LOCALE_RESOURCE_TYPE.WEB.getValue());
                sysLocaleResource.setResourceKey(row.getCell(2).getStringCellValue());
                sysLocaleResource.setResourceValue(row.getCell(2).getStringCellValue());
                System.out.println(sql(sysLocaleResource));

                bufferWritter.write(sql(sysLocaleResource));

                sysLocaleResource.setId(snowflakeIdMaker.nextId());
                sysLocaleResource.setLanguageCode("US/en");
                sysLocaleResource.setLanguageNameRdd("English");
                sysLocaleResource.setResourceType(CommonEnumUtil.SYS_LOCALE_RESOURCE_TYPE.WEB.getValue());
                sysLocaleResource.setResourceKey(row.getCell(2).getStringCellValue());
                sysLocaleResource.setResourceValue(row.getCell(3).getStringCellValue());
                System.out.println(sql(sysLocaleResource));

                bufferWritter.write(sql(sysLocaleResource));
            }

            // IMPP 资源
            Sheet imppSheet = wb.getSheet("IMPP");
            i =0;
            for (; i < imppSheet.getLastRowNum(); i++) {
                row = imppSheet.getRow(i);

//                if(row == null||  row.getCell(2) == null||  row.getCell(3) == null){
//                    continue;
//                }
                System.out.println(snowflakeIdMaker.nextId()+" IMPP 行:"+i);
                row.getCell(2).setCellType(CellType.STRING);
                row.getCell(3).setCellType(CellType.STRING);
                sysLocaleResource.setId(snowflakeIdMaker.nextId());
                sysLocaleResource.setLanguageCode("CN/zh");
                sysLocaleResource.setLanguageNameRdd("简体中文");
                sysLocaleResource.setResourceType( getType(row.getCell(1).getStringCellValue()));
                sysLocaleResource.setResourceKey(row.getCell(3).getStringCellValue());
                sysLocaleResource.setResourceValue(row.getCell(3).getStringCellValue());
                System.out.println(sql(sysLocaleResource));

                bufferWritter.write(sql(sysLocaleResource));

                sysLocaleResource.setId(snowflakeIdMaker.nextId());
                sysLocaleResource.setLanguageCode("US/en");
                sysLocaleResource.setLanguageNameRdd("English");
                sysLocaleResource.setResourceType( getType(row.getCell(1).getStringCellValue()));
                sysLocaleResource.setResourceKey(row.getCell(3).getStringCellValue());
                sysLocaleResource.setResourceValue(row.getCell(4).getStringCellValue());
                System.out.println(sql(sysLocaleResource));

                bufferWritter.write(sql(sysLocaleResource));
            }

            // WMS资源
            Sheet wmsSheet = wb.getSheet("WMS");
            i =0;
            for (; i < wmsSheet.getLastRowNum(); i++) {
                row = wmsSheet.getRow(i);

                System.out.println(snowflakeIdMaker.nextId()+" WMS 行:"+i);
                row.getCell(2).setCellType(CellType.STRING);
                row.getCell(3).setCellType(CellType.STRING);
                sysLocaleResource.setId(snowflakeIdMaker.nextId());
                sysLocaleResource.setLanguageCode("CN/zh");
                sysLocaleResource.setLanguageNameRdd("简体中文");
                sysLocaleResource.setResourceType( getType(row.getCell(1).getStringCellValue()));
                sysLocaleResource.setResourceKey(row.getCell(3).getStringCellValue());
                sysLocaleResource.setResourceValue(row.getCell(3).getStringCellValue());
                System.out.println(sql(sysLocaleResource));

                bufferWritter.write(sql(sysLocaleResource));

                sysLocaleResource.setId(snowflakeIdMaker.nextId());
                sysLocaleResource.setLanguageCode("US/en");
                sysLocaleResource.setLanguageNameRdd("English");
                sysLocaleResource.setResourceType( getType(row.getCell(1).getStringCellValue()));
                sysLocaleResource.setResourceKey(row.getCell(3).getStringCellValue());
                sysLocaleResource.setResourceValue(row.getCell(4).getStringCellValue());
                System.out.println(sql(sysLocaleResource));

                bufferWritter.write(sql(sysLocaleResource));
            }

            bufferWritter.flush();
            bufferWritter.close();

            System.out.println("Done");
        } catch (IOException e) {
            System.out.println(i);
            e.printStackTrace();
        } catch (InvalidFormatException e) {
            System.out.println(i);
            e.printStackTrace();
        }
    }

    static int getType(String name){
        if("错误提示".equals(name.trim())){
            return CommonEnumUtil.SYS_LOCALE_RESOURCE_TYPE.EXCEPTION_SOLUTION.getValue();
        }else {
            return CommonEnumUtil.SYS_LOCALE_RESOURCE_TYPE.EXCEPTION_DETAIL.getValue();
        }
    }

    private static String sql(SysLocaleResource sysLocaleResource){
        return "insert into sys_locale_resource " +
                "(id,is_valid,is_deleted,create_user,create_date_time,modify_user,modify_date_time,resource_type,language_code," +
                "language_name_rdd,resource_key,resource_value,is_system) " +
                "values " +
                "("+sysLocaleResource.getId()+",1,2,\"system\",\"" + TimeTool.getNowTime(true)+"\",\"system\",\"" + TimeTool.getNowTime(true)+
                "\","+sysLocaleResource.getResourceType()+",\""+sysLocaleResource.getLanguageCode()+"\",\""+sysLocaleResource.getLanguageNameRdd()+"\",\""
        +sysLocaleResource.getResourceKey().replaceAll("\"","\\\\\\\"")+"\",\""+sysLocaleResource.getResourceValue().replaceAll("\"","\\\\\\\"")+"\",1);\n";
    }

}
